/* =========================================================================

InDesign ExtendScript

NAME: Karusel.js
VERSION: 1.0

AUTHOR: Vitaly Batushev
DATE  : 19.03.2004

DESCRIPTION:     :)


SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */
with (app) {
	if (documents.length < 1) { alert("  "); exit();	}
	if (selection.length < 2) {	alert(" : 2 !");	exit();	}
	if (selection[0].constructor.name == 'InsertionPoint') {
		alert(" !");	exit();
	}
	if (selection[0].constructor.name == 'Text') {
		alert(" !");	exit();
	}
	
	var myDoc = activeDocument;
	var mySel = selection;
		
	var ivArr = new Array;
	var ihArr = new Array;
	var objArr = new Array;
		
	for (i = 0; i <selection.length; i++) {
		tGB = selection[i].geometricBounds;
		ivArr.push(tGB[0]);
		ihArr.push(tGB[1]);		
	}	
	
	ivArr = ivArr.sort(compareNumbers);
	ihArr = ihArr.sort(compareNumbers);
	
	for (y = 0; y < ihArr.length; y++) {
		for (i = 0; i < selection.length; i++) {
			tGB = selection[i].geometricBounds;
			if (ihArr[y] == tGB[1]) {
				objArr.push(selection[i]);
			}
		}
	}

	var fsBounds = objArr[0].geometricBounds;
	var ssBounds = objArr[1].geometricBounds;
	var psBounds = objArr[objArr.length - 2].geometricBounds;
	var lsBounds = objArr[objArr.length - 1].geometricBounds;
	
	var myDlg = dialogs.add({name: " "});
	with (myDlg) {
		with (dialogColumns.add()) {
		with (radiobuttonGroups.add()) {
			var swReverse = radiobuttonControls.add({staticLabel: " ", checkedState: true});
			var swNoReverse = radiobuttonControls.add({staticLabel: " ", checkedState: false});
			var swToLeft = radiobuttonControls.add({staticLabel: "  ", checkedState: false});
			var swFlip = radiobuttonControls.add({staticLabel: "    ", checkedState: false});
		}
		}
	}
	result = myDlg.show();
	if (result == true) {
	//  
	if (swReverse.checkedState == true ) {
		var fPlace = lsBounds[3] - fsBounds[3];
		objArr[0].move(undefined, [fPlace, 0]);
		var myShift = -(objArr[1].geometricBounds[1] - fsBounds[1]);
		for (o = 1; o < objArr.length; o++) {
			objArr[o].move(undefined, [myShift, 0]);	
		}
	}
	//  
	if (swNoReverse.checkedState == true ) {
		var LastPlace = -(lsBounds[1] - fsBounds[1]);
		objArr[objArr.length - 1].move(undefined, [LastPlace, 0]);		
		var myShift = lsBounds[3] - psBounds[3];
		for (o = 0; o < (objArr.length - 1); o++) {
			objArr[o].move(undefined, [myShift, 0]);	
		}
	}
	// 
	if (swToLeft.checkedState == true) {	
	var FirstPoint = new Array;
	for (i = 0;  i < objArr.length; i++) {
		FirstPoint.push(objArr[i].geometricBounds[1]);
	}
	for (i = 0; i < objArr.length; i++) {
		objArr[i].move([FirstPoint[FirstPoint.length - (i + 1)],objArr[i].geometricBounds[0]],undefined);
	}
	}

	//     
	if (swFlip.checkedState == true ) {
		var fPlace = lsBounds[3] - fsBounds[3];
		objArr[0].move(undefined, [fPlace, 0]);
		var LastPlace = -(lsBounds[1] - fsBounds[1]);
		objArr[objArr.length - 1].move(undefined, [LastPlace, 0]);		
	}
	}
}
function compareNumbers(a, b) {
   return a - b
}